;***********************************************************
;    ,     (    ) 
;  , ,      ,   ,     :)

.code
 .importzp	IOS_HT
 .importzp	IOS_VT
 .import	IOS_COUT_SCR
 .import	IOS_FAST_COUT
 .import	IOS_CR
 .import	IOS_PRINT
 .import	IOS_BYTEOUT
 .import	IOS_DIGOUT
 .import	IOS_COUT
 .import	IOS_CLRSCR
 .import	IOS_KEYIN
 .import	IOS_PRINT_PTR

 .import	DOS_TYPE2CHAR
 .import	DOS_GET_CATALOG
 .import	DOS_GET_FNAME
 .import	DOS_AR

.data
M_CURSOR:	.byte 0
.bss
M_CNT:		.res 1
M_SAVE_ATTR:	.res 1
.code


;***********************************************************
;   ( ) 
;
MENU:
 LDA IOS_ATTR
 STA M_SAVE_ATTR

MENU1:
 LDA #$2F
 STA IOS_ATTR
 JSR IOS_SET_VID_MODE
 JSR IOS_CLRSCR

 print "--    --"

 LDA #30
 STA IOS_VT
 JSR IOS_BASCALC

 LDA FNAME
 CMP #$8D
 BNE @fname_print

@about_print:
 print       "    (C)    1993-2018     v1.9"
 print_WO_CR "           USR, Ravodin & ..."
 LDA #0
 STA IOS_HT
 JMP @0

@fname_print:
 LDX #0
@1:
 LDA FNAME,X
 JSR IOS_COUT_SCR
 INX
 CMP #$8D
 BNE @1

@0:
 LDA #$2E
 STA IOS_ATTR
 LDA #3
 STA IOS_VT
 JSR IOS_BASCALC
 print "    :"

 LDA #$2A
 STA IOS_ATTR
 LDA #20
 STA IOS_VT
 JSR IOS_BASCALC
 print "     ,"
 JSR IOS_CR
 print "      ."
 JSR IOS_CR
 JSR IOS_CR
 print "    "
 JSR IOS_CR
 print " ."

 LDA #$01
 STA IOS_ATTR
 LDA #27
 JSR IOS_BASCALC
 LDA #36
 STA IOS_HT
 print "F1 - ."

;
;    
;
MENU_NSTRING	= 6

MENU_REPRINT:
 LDA #6
 STA IOS_VT
 JSR IOS_BASCALC
 set_ptr MS_PTR_A, MENU_STRINGS
 LDY #0
 STY M_CNT

@main_loop:
 LDA M_CURSOR
 CMP M_CNT
 BEQ @curs
 LDA #$3B
 .byte $2C
@curs:
 LDA #$03
 STA IOS_ATTR

@line_loop:
 LDA (MS_PTR_A),Y
 BEQ @next_line
 JSR IOS_COUT_SCR
 JSR INC_MS_PTR_A
 JMP @line_loop

@next_line:
 JSR INC_MS_PTR_A
 JSR IOS_CR
 JSR IOS_CR
 INC M_CNT
 LDA M_CNT
 CMP #MENU_NSTRING
 BCC @main_loop

;
;          
;
MENU_KEYPROC:
 JSR KEYIN

 LDY #4
 LDX #0
@loop:
 CMP MENU_KEYS,X
 BEQ @match
 INX
 INX
 INX
 DEY
 BPL @loop
 BMI MENU_KEYPROC	; -JMP.

@match:
 LDA MENU_KEYS+1,X
 STA MS_PTR_A+0
 LDA MENU_KEYS+2,X
 STA MS_PTR_A+1
 JMP (MS_PTR_A)

;
;   
;
M_ESC:
 LDA M_SAVE_ATTR	;   , ,
 STA IOS_ATTR		;        
 JMP IOS_SET_VID_MODE
;
M_UP:
 LDX M_CURSOR
 BNE @0
 LDX #MENU_NSTRING
@0:
 DEX
 STX M_CURSOR
 JMP MENU_REPRINT
;
M_DOWN:
 LDX M_CURSOR
 INX
 CPX #MENU_NSTRING
 BCC @0
 LDX #0
@0
 STX M_CURSOR
 JMP MENU_REPRINT
;
M_HELP:
 JSR HELP
 JMP MENU1
;
M_ENTER:
 LDA M_CURSOR
 ASL A
 TAX
 LDA MENU_ROUTES+0,X
 STA MS_PTR_A+0
 LDA MENU_ROUTES+1,X
 STA MS_PTR_A+1
 JMP (MS_PTR_A)

;
;       
;
.rodata
MENU_STRINGS:
 .asciiz "                    "
 .asciiz "    "
 .asciiz "                    "
 .asciiz "      "
 .asciiz "                  "
 .asciiz "               "
MENU_ROUTES:
 .addr M_LOAD_FILE
 .addr M_INSERT_FILE
 .addr M_SAVE_FILE
 .addr M_SAVE_AS
 .addr M_CLEARBUF
 .addr M_MAIN_EXIT
MENU_KEYS:
  key_descriptor $8D, M_ENTER
  key_descriptor $9B, M_ESC
  key_descriptor $84, M_HELP
  key_descriptor $99, M_UP
  key_descriptor $9A, M_DOWN
.code


;***********************************************************
;  .         
;
HELP:
 LDA IOS_ATTR
 PHA
 LDA #$80
 STA IOS_ATTR
 JSR IOS_SET_VID_MODE
 JSR IOS_CLRSCR
;
 set_ptr MS_PTR_A, @text
 LDY #0
;
@loop:
 LDA (MS_PTR_A),Y
 BNE @1
 LDA #$8D
@1:
 CMP #$80
 BEQ @0
 JSR IOS_COUT_SCR
 JSR INC_MS_PTR_A
 JMP @loop
;
@0:
 JSR PRINT_OS_TYPE
;
 SEC
 LDA #<text_buffer_HI
 SBC #<text_buffer_LO
 PHA
 LDA #>text_buffer_HI
 SBC #>text_buffer_LO
 PHA
 print "          $%% "
;
;
 SEC
 LDA ED_P_HI_CUR+0
 SBC ED_P_LO_CUR+0
 PHA
 LDA ED_P_HI_CUR+1
 SBC ED_P_LO_CUR+1
 PHA
 TAX
 print_WO_CR "       $%%  ("
 TXA
 JSR DECIM_OUT
 print " )"
;
 JSR KEYIN
;
 PLA
 STA IOS_ATTR
 JMP IOS_SET_VID_MODE

@text:
 .asciiz "    :"
 .asciiz ""
 .asciiz " -  ;"
 .asciiz " -  ;"
 .asciiz "9   -  ;"
 .asciiz ""
 .asciiz "1   -    ;"
 .asciiz "2   -   /;"
 .asciiz ""
 .asciiz "7   -     ;"
 .asciiz "8   -     ;"
 .asciiz ""
 .asciiz "0   -    ;"
 .asciiz "F2   -  ;"
 .asciiz ""
 .asciiz "  -  /;"
 .asciiz "F1   -  ."
 .asciiz ""
 .asciiz ""
 build_data "          "	;    :       
 .byte      "         : "
 .byte $80

;
;   
;
PRINT_OS_TYPE:
 lda DOS_AR
 asl a
 tay
 ldx @table+0,Y
 lda @table+1,Y
 jmp IOS_PRINT_PTR

.macro msg str
 .local @0
 .rodata
   @0: .asciiz str
 .code
   .word @0
.endmacro

@table:
 msg "?"		; DOS_AR_UNKNOW
 msg "Agat-DOS3.3; b60"	; DOS_AR_DOS33_AGAT
 msg "ALV Super DOS"	; DOS_AR_ALV_AGAT
 msg "-7  ''"	; DOS_AR_IKP7_SCHM
 msg "-7"		; DOS_AR_IKP7
 msg "-9"		; DOS_AR_IKP9
 msg "-"	; DOS_AR_DOK
 msg "BTK / The BEST"	; DOS_AR_BTK


;***********************************************************
;      .
; :    ģ .
;     $8D.
;          .
;
.bss
FNAME:	.res 31
.code

ENTER_FILENAME:
 LDA #12
 STA IOS_VT
 JSR IOS_BASCALC
 JSR IOS_CLREOL
 LDA #$71
 STA IOS_ATTR
 print "  :"
 JSR IOS_CR
 LDA #$72
 STA IOS_ATTR

@loop:
 LDX #0
 STX IOS_HT

@loop_name:
 LDA FNAME,X
 CMP #$8D
 BEQ @keyin
 JSR IOS_COUT_SCR
 INX
 CPX #30
 BCC @loop_name

@keyin:
 JSR IOS_CLREOL
 JSR IOS_KEYIN_KBD
 CMP #$9B
 BEQ @fin_Escape
 CMP #$8D
 BEQ @fin_Ok
 CMP #$88
 BEQ @backspace

 CPX #30
 BCS @keyin
 TAY
 AND #$60
 BEQ @keyin
 TYA
 STA FNAME,X
 INX
@0:
 LDA #$8D
 STA FNAME,X
 BNE @loop	; -JMP.

@backspace:
 CPX #0
 BEQ @keyin
 DEX
 BPL @0		; -JMP.

@fin_Ok:
 CLC
 .byte $24
@fin_Escape:
 SEC
 RTS


;***********************************************************
;     
;
.bss
FLIST:		.res $1000
L_PRINT:	.res 1
L_TOP:		.res 1
L_CURS:		.res 1
.code

SELECT_FILENAME:
 JSR IOS_CLRSCR
 set_ptr_AX FLIST
 JSR DOS_GET_CATALOG
 BCC @ok_cat

;   

 LDA #$01
 STA IOS_ATTR
 LDA #31
 STA IOS_VT
 JSR IOS_BASCALC
 print "  "
 JMP KEYIN

@ok_cat:
 LDA FLIST+2
 CMP #$8D
 BNE @ok2_cat
 print " "
 JMP KEYIN

@ok2_cat:
 LDA #0
 JSR IOS_BASCALC
 LDA #$2E
 STA IOS_ATTR
 print "  :"

 LDA #0
 STA L_TOP
 STA L_CURS

;   

@draw_all:
 LDA L_TOP
 STA L_PRINT

 LDA #0
 STA IOS_HT
 LDA #2
 STA IOS_VT
 JSR IOS_BASCALC

@loop_r:
 LDA L_PRINT		
 JSR FLIST_CALC

 LDA L_PRINT
 CMP L_CURS
 BNE @0
 LDA #$12	; i 01 0010
 .byte $2C
@0:
 LDA #$3A	; n 11 1010
 STA IOS_ATTR

 LDY #2
 LDA (MS_PTR_A),Y
 CMP #$8D
 BEQ @end_of_list

 LDY #0
 LDA (MS_PTR_A),Y
 AND #$7F
 BEQ @1
 LDA IOS_ATTR
 AND #$E8
 ORA #$04 	; n 10 1100 / i 00 0100  iYxBGR
 STA IOS_ATTR
@1:
 LDA (MS_PTR_A),Y
 JSR DOS_TYPE2CHAR
 JSR IOS_COUT_SCR

 LDA #' '
 JSR IOS_COUT_SCR

 LDY #1
 LDA (MS_PTR_A),Y
 JSR DECIM_OUT

 LDA #' '
 JSR IOS_COUT_SCR

 LDY #2
@loop_n:
 LDA (MS_PTR_A),Y
 TAX
 AND #$60 	; :01100000
 BNE @4
 ORA #$40	; :01000000
 .byte $24
@4:
 TXA
 JSR IOS_FAST_COUT
 INY
 CPY #27
 BNE @loop_n

 LDA IOS_VT
 CMP #31
 BCS @keyin

 INC L_PRINT
 JSR IOS_CR
 JMP @loop_r

;  

@end_of_list:

@keyin:
 JSR KEYIN
 CMP #$99
 BEQ @up
 CMP #$9A
 BEQ @down
 CMP #$9B
 BEQ @sel_Escape
 CMP #$8D
 BNE @keyin

; ,     T ?
;  MS_PTR_A     

 LDA L_CURS
 JSR FLIST_CALC
 LDY #0
 LDA (MS_PTR_A),Y
 AND #$7F
 BNE @keyin

 add2_ptr_byte MS_PTR_A, 2

 CLC
 RTS

@sel_Escape:
 SEC
 RTS

; 

@up:
 LDX L_CURS
 BEQ @keyin
 DEX
 STX L_CURS

 CPX L_TOP
 BCS @2
 DEC L_TOP
@2:
 JMP @draw_all

@down:
 LDA L_CURS
 CLC
 ADC #1
 JSR FLIST_CALC
 LDY #2
 LDA (MS_PTR_A),Y
 CMP #$8D
 BEQ @keyin

 INC L_CURS

 CLC
 LDA L_TOP
 ADC #29
 CMP L_CURS
 BCS @3
 INC L_TOP
@3:
 JMP @draw_all

;
;    8- ,
;   16        
; MS_PTR_A := A * 32 + #FLIST
;
FLIST_CALC:
 STA MS_PTR_A+0		
 LDA #0
 ASL MS_PTR_A+0
 ROL A
 ASL MS_PTR_A+0
 ROL A
 ASL MS_PTR_A+0
 ROL A
 ASL MS_PTR_A+0
 ROL A
 ASL MS_PTR_A+0
 ROL A
 PHA
 LDA MS_PTR_A+0
 ADC #<FLIST
 STA MS_PTR_A+0
 PLA
 ADC #>FLIST
 STA MS_PTR_A+1
 RTS


;***********************************************************
;  

;
;     
;
DECIM_OUT:
 CMP #0
 BEQ @000

 TAX
 LDA #0
 TAY
 SED

@loop:
 CLC
 ADC #1
 BCC @1
 INY
@1:
 DEX
 BNE @loop

 CLD
 PHA
 TYA
 JSR IOS_DIGOUT
 PLA
 JMP IOS_BYTEOUT

@000:
 print_WO_CR "000"
 RTS

;
;        
;   =1
;
KEYIN:
 LDA $C000
 BPL KEYIN
 STA $C010
 SEC		;         
 RTS


;***********************************************************
; /  /  
;
CREATE_BUFFER:

;    

 LDA #$8D
 STA FNAME

; - 

 set_ptr ED_P_LO_CUR, text_buffer_LO
 set_ptr ED_P_HI_CUR, text_buffer_HI

; -    CR

 LDA #CHAR_CR
 LDY #$00
 STA (ED_P_LO_CUR),Y

 JSR INC_P_LO_CUR

 JSR DEC_P_HI_CUR

 LDA #CHAR_CR
 STA (ED_P_HI_CUR),Y

; ݣ  

 copy_ptr ED_P_LO_CUR, ED_P_LO_BUF, ED_P_TOP_LN
 copy_ptr ED_P_HI_CUR, ED_P_HI_BUF

;     

 LDA #$01
 STA ED_NT_LN_DC+0
 STA ED_NLINE_DC+0

 LDA #$00
 STA ED_NLINE_DC+1
 STA ED_NT_LN_DC+1

 STA ED_VIRT_SPC
 RTS


;***********************************************************
;         
;
M_LOAD_FILE:
 JSR SELECT_FILENAME
 BCS MENU2

 JSR CREATE_BUFFER

 LDA #$8D
 STA FNAME+30,Y

 LDY #29		;     
 BIT RTS2		; V=1
@l1:
 LDA (MS_PTR_A),Y
 BVC @solution
 CMP #$A0
 BNE @non_space

@space:
 LDA #$8D
 BNE @solution		; -JMP.

@non_space:
 CLV

@solution:
 STA FNAME,Y
 DEY
 BPL @l1

 set_ptr_AX FNAME
 JSR DOS_GET_FNAME

 JSR INSERT_FILE
 JMP M_ESC


;***********************************************************
;            
;
M_INSERT_FILE:
 JSR SELECT_FILENAME
 BCS MENU2

 LDX MS_PTR_A+0		;       FNAME
 LDA MS_PTR_A+1
 JSR DOS_GET_FNAME

 JSR INSERT_FILE

 LDA #0			;     
 STA ED_VIRT_SPC

 JMP M_ESC

;
;        
;
MENU2:
 JMP MENU1


;***********************************************************
;       
;
M_SAVE_AS:
 JSR ENTER_FILENAME
 BCS MENU2


;***********************************************************
;    
;
M_SAVE_FILE:
 LDA FNAME
 CMP #$8D
 BEQ M_SAVE_AS

 set_ptr_AX FNAME
 JSR DOS_GET_FNAME

 JSR SAVE_FILE
M_ESC2:
 JMP M_ESC


;***********************************************************
;      
;
M_CLEARBUF:
 JSR CREATE_BUFFER
 JMP M_ESC


;***********************************************************
;   
;
M_MAIN_EXIT:
 LDA #$FF
 STA ED_FINISH
 JMP M_ESC
