#!/bin/sh

clear
echo ""
echo "-- build --"

name=`basename ${0%.sh}`

libs="IOSub DOS"

case btk in
btk)
  fil_type=B_TYPE
  os_type=OS_TYPE_BTK
  os_desc=agat-B-BTK.cfg
  ;;

dos)
  fil_type=B_TYPE
  os_type=OS_TYPE_BAS
  os_desc=agat-B-IKP+Basic-60.cfg
  ;;

dok)
  fil_type=K_TYPE
  os_type=OS_TYPE_DOK
  os_desc=agat-K-DOK.cfg
  ;;
esac


for nm in $name $libs
do
  rm -f ${nm}.o ${nm}.lst ${nm}.fil ${nm}.lbl
  if ca65 -g -l -v -D $fil_type -D $os_type -o ${nm}.o ${nm}.asm
  then
    all_fn=${all_fn}" "${nm}.o
    echo "$nm Ok"
  else
    echo "Fault :(("
    sleep 3
    exit
  fi
done

if ld65 -Ln ${name}.lbl -m ${name}.map -C $os_desc -o ${name}.fil $all_fn
then
  ./map ${name}.lbl
  echo Ok
  sleep 1
else
  sleep 4
fi
