;***********************************************************
;  
;       
;
.importzp IOS_GC_CHAR

.rodata
;  ,   EDITOR     

.macro key_descriptor code, proc
  .byte code
  .addr proc
.endmacro

ED_KEYS_TABLE
  key_descriptor $8D, ED_K_ENTER
 
  key_descriptor $95, ED_K_RIGHT
  key_descriptor $88, ED_K_LEFT
  key_descriptor $99, ED_K_UP
  key_descriptor $9A, ED_K_DOWN

  key_descriptor $9B, ED_K_ESC
  key_descriptor $84, ED_K_HELP

  key_descriptor $9D, ED_K_LEFT_CUTLINE		; 7
  key_descriptor $9E, ED_K_RIGHT_CUTLINE	; 8
  key_descriptor $9F, ED_K_DELLINE		; 9
  key_descriptor $91, ED_K_INS_MODE		; 2
  key_descriptor $90, ED_K_DELETE		; 1
  key_descriptor $81, ED_K_NLINE_MODE		; 0
  key_descriptor $85, ED_K_SCR_MODE		; F2

  key_descriptor 0,   ED_K_SYMBOL


.bss
ED_WID_WIN	.res 1		;   +1,   ED_CALC_WIDTH_WIN
MS_ROUT_PTR	.res 2

.data
ED_INS_MODE	.byte 0		;  / 
.code


;  

ED_BUG:
 LDA #0
 STA IOS_HT
 LDA #31
 STA IOS_VT
 JSR IOS_BASCALC 
 print " :"
 LDX #0
@loop:
 LDA ED_P_LO_BUF,X
 JSR IOS_BYTEOUT
 LDA #' '
 JSR IOS_COUT_SCR
 INX
 CPX #10
 BNE @loop
 
 .byte 2

EDITOR

;      

 cmp_ptr_ptr ED_P_LO_CUR, ED_P_LO_BUF
 BCC ED_BUG

 cmp_ptr_ptr ED_P_HI_BUF, ED_P_HI_CUR
 BCC ED_BUG

 cmp_ptr_ptr ED_P_TOP_LN, ED_P_LO_BUF
 BCC ED_BUG

 cmp_ptr_ptr ED_P_LO_CUR, ED_P_TOP_LN
 BCC ED_BUG

;  , ģ  

 JSR CALL_BASCALC

 LDA ED_INS_MODE
 BMI @1
 LDX #$5F			;   ,  ͣ -  ڣ
 .byte $2C
@1:
 LDX #'_'
 LDA ED_VIRT_SPC
 BEQ @0
 LDX #'^'
@0:
 STX IOS_GC_CHAR
 JSR IOS_KEYIN_KBD

;      

 LDY #0
 TAX
@loop
 LDA ED_KEYS_TABLE,Y
 BEQ @match
 TXA
 CMP ED_KEYS_TABLE,Y
 BNE @next

;   

@match
 TXA
 INY
 LDX ED_KEYS_TABLE,Y
 STX MS_ROUT_PTR+0
 INY
 LDX ED_KEYS_TABLE,Y
 STX MS_ROUT_PTR+1
 JMP (MS_ROUT_PTR)

;   

@next
 INY
 INY
 INY
 BPL @loop			; -JMP.


;***********************************************************
;    
;
ED_K_HELP
 JSR HELP
 JSR IOS_CLRSCR
 JSR OUT_FULL_SCREEN
 JMP EDITOR


;***********************************************************
; /   
;  :    
;    ,    ,    
;
ED_K_NLINE_MODE
 LDA DOS_WIND_X1
 CMP #5
 BCC @1
 SBC #5
 .byte $2C
@1
 ADC #5
 STA DOS_WIND_X1

 JMP ED_SCROLL_TO_CURSOR


;***********************************************************
;  
;
ED_K_SCR_MODE
 LDA IOS_ATTR
 EOR #$80
 STA IOS_ATTR
 JSR SET_WINDOW

;
;     ,       
;
ED_SCROLL_TO_CURSOR:
 JSR IOS_CLRSCR

;       ,
;    TOP_LINE    

 JSR FIND_BEG_TOP_LINE

;      ,       ,
;          

 LDA #0
 STA ED_VIRT_SPC

@loop
 JSR OUT_FULL_SCREEN
 LDA MS_PH_LINE
 BPL @0
 JSR SCROLL_TO_NEXT_PH_LINE
 JMP @loop

@0
 JMP EDITOR


;***********************************************************
;      
;
ED_K_DELETE
 LDY #$00
 LDA (ED_P_HI_CUR),Y
 CMP #CHAR_CR
 BEQ @fin
 JSR INC_P_HI_CUR
 JSR OUT_REST_FROM_CURSOR2
;JSR OUT_REST_FROM_CURSOR
; JSR OUT_FULL_SCREEN
@fin
 JMP EDITOR


;***********************************************************
;   / 
;
ED_K_INS_MODE
 LDA ED_INS_MODE
 EOR #$FF
 STA ED_INS_MODE
 JMP EDITOR


;***********************************************************
;   
;
ED_K_RIGHT_CUTLINE
 JSR DEL_UP_UNTIL_CR
 JSR OUT_REST_FROM_CURSOR2
 JMP EDITOR


;***********************************************************
;   
;
ED_K_LEFT_CUTLINE
 JSR DEL_DN_UNTIL_CR
 JSR OUT_FULL_SCREEN
 JMP EDITOR


;***********************************************************
;   
;
ED_K_DELLINE

;     

 JSR DEL_DN_UNTIL_CR
 JSR DEL_UP_UNTIL_CR

;  ,    

 cmp_ptr_ptr ED_P_HI_CUR, ED_P_HI_BUF
 BCS @fin

;    -  ţ CHAR_CR

 JSR INC_P_HI_CUR

@fin:
 JSR OUT_FULL_SCREEN
 JMP EDITOR
 

;***********************************************************
;    
;
.bss
MS_CUR_CHAR	.res 1		;  ,    
.code

ED_K_SYMBOL
 LDY #$00
 PHA
 LDA (ED_P_HI_CUR),Y
 STA MS_CUR_CHAR
 CMP #CHAR_CR
 BNE @chg_char

;    ,   

@spc_loop
 JSR IS_P_LO_EQU_HI
 BNE @0
 PLA
 JMP ED_NO_MEMORY_ERROR

@0
 LDA ED_VIRT_SPC
 BEQ @1

;    ,  

 LDA #CHAR_SPC
 STA (ED_P_LO_CUR),Y
 JSR INC_P_LO_CUR
 DEC ED_VIRT_SPC
 BPL @spc_loop

;    ,     

@chg_char
 LDA ED_INS_MODE		;   ,    
 BMI @1				;    ,     
 JSR INC_P_HI_CUR		;      ...

;     

@1
 PLA
 STA (ED_P_LO_CUR),Y

 JSR INC_P_LO_CUR		; ...     
 JSR IOS_FAST_COUT

; ,    

 LDA ED_PH_COL
 CMP DOS_WIND_X2
 BEQ @next_ph_line

; ݣ    -    

 INC ED_PH_COL
 BNE @chk_refresh		; -JMP.

;     

@next_ph_line
 LDA DOS_WIND_X1
 STA ED_PH_COL
 LDA ED_PH_LINE
 CMP DOS_WIND_Y2
 BNE @2

;   ,    

 LDX #$01
 JSR SCROLL_UP_AND_OUT_SCREEN
 JMP EDITOR

;     

@2
 INC ED_PH_LINE
 LDA MS_CUR_CHAR
 CMP #CHAR_CR
 BNE @chk_refresh

;      (CR)
;    :    

 JSR OUT_REST_FROM_CURSOR
 JMP EDITOR

;       (  ),
; ,    , ,  ӣ  

@chk_refresh
 LDA ED_INS_MODE
 BPL @jmp_editor

 LDA MS_CUR_CHAR
 CMP #CHAR_CR
 BEQ @jmp_editor
 JSR OUT_REST_FROM_CURSOR2

@jmp_editor
 JMP EDITOR


;***********************************************************
;   
;
ED_K_ESC
 RTS


;***********************************************************
;  
;
ED_K_RIGHT
 LDY #$00
 LDA (ED_P_HI_CUR),Y
 CMP #CHAR_CR
 BNE ED_K_R_IN_LINE

;     ...

 LDA ED_PH_COL
 CMP DOS_WIND_X2
 BNE @1

; ...      

 cmp_ptr_ptr_bne ED_P_HI_CUR, ED_P_HI_BUF, @0

; ,    ...

 JSR DOS_BELL
 JMP EDITOR

; ...       

@0
 LDA #$00
 STA ED_VIRT_SPC

 LDY #ED_NLINE_DC
 JSR INC_DECIMAL

 BCC ED_K_R_IN_LINE		; -JMP.

;      

@1
 INC ED_VIRT_SPC
ED_K_R_LOC2
 INC ED_PH_COL
 JMP EDITOR

;    

ED_K_R_IN_LINE
 JSR COPY_CHAR_HI2LO

 LDA ED_PH_COL
 CMP DOS_WIND_X2
 BNE ED_K_R_LOC2

;   ,      

 LDA DOS_WIND_X1
 STA ED_PH_COL

;     

ED_K_R_NEXT_PH_LINE
 LDA ED_PH_LINE
 CMP DOS_WIND_Y2
 BNE @4

;     ,   

 LDX #$01
 JSR SCROLL_UP_AND_OUT_SCREEN
 JMP EDITOR

;    -   

@4
 INC ED_PH_LINE
 JMP EDITOR


;***********************************************************
;  ""
;
.bss
MS_NWLN_CNT	.res 1		;    ޣ      
.code

ED_K_ENTER
 LDY #$00
 STY MS_NWLN_CNT

;        -   

 JSR IS_P_LO_EQU_HI
 BNE ED_K_ENT_LOOP
 JMP ED_NO_MEMORY_ERROR

;  ģ     
; (agatstyle         ţ )

ED_K_ENT_LOOP

;         ...

 LDA (ED_P_HI_CUR),Y
 STA (ED_P_LO_CUR),Y
 JSR INC_P_LO_CUR

;     ?
;            
; -     ""

 CMP #CHAR_CR
 BEQ ED_K_ENT_EOL

;  

 JSR INC_P_HI_CUR
 LDA ED_PH_COL
 CMP DOS_WIND_X2
 BEQ ED_K_ENT_NEXTPLINE
 INC ED_PH_COL
 BNE ED_K_ENT_LOOP		; -JMP.

;     -   

ED_K_ENT_NEXTPLINE
 LDA DOS_WIND_X1
 STA ED_PH_COL
 LDA ED_PH_LINE
 CMP DOS_WIND_Y2
 BNE @0
 INC MS_NWLN_CNT
 BNE ED_K_ENT_LOOP		; -JMP.

@0
 INC ED_PH_LINE
 BNE ED_K_ENT_LOOP		; -JMP.

;    ,
;     

ED_K_ENT_EOL
 LDA DOS_WIND_X1
 STA ED_PH_COL
 INC ED_PH_COL

 LDY #ED_NLINE_DC
 JSR INC_DECIMAL

; LDA #$01		     ASM-,
; STA ED_VIRT_SPC	      .
 LDA #$00
 STA ED_VIRT_SPC

 LDA ED_PH_LINE
 CMP DOS_WIND_Y2
 BNE @1

;       -  ...

 INC MS_NWLN_CNT
 BNE @2				; -JMP.

; ... -  

@1
 INC ED_PH_LINE
@2

; ,             ?

 LDX MS_NWLN_CNT
 BEQ @3

 JSR SCROLL_UP_AND_OUT_SCREEN
 JMP EDITOR

@3
 JSR OUT_REST_FROM_CURSOR
 JMP EDITOR


;***********************************************************
;  
;
ED_K_LEFT

;      ?

 LDA ED_VIRT_SPC
 BEQ @2
 
;       ޣ   

 DEC ED_VIRT_SPC
@1
 DEC ED_PH_COL
 JMP EDITOR

;   

@2
 cmp_ptr_ptr_bne ED_P_LO_CUR, ED_P_LO_BUF, @0

;      -   ( )

 JSR DOS_BELL
 JMP EDITOR

@0
 JSR COPY_CHAR_LO2HI
 LDX ED_PH_COL
 CPX DOS_WIND_X1
 BNE @1

;     ,     

 LDX DOS_WIND_X2
 STX ED_PH_COL
 CMP #CHAR_CR
 BNE ED_K_L_PREV_PH_LINE

;     .   ?
;    

 JSR CALC_PHYS_LINE_PTR2

 LDA MS_PTR_A+0
 SEC
 SBC ED_P_LO_CUR+0
 STA ED_VIRT_SPC

;  ,          ?

ED_K_L_PREV_PH_LINE
 LDA ED_PH_LINE
 CMP DOS_WIND_Y1
 BEQ @3

;   -   

 DEC ED_PH_LINE
 JMP EDITOR

;  -    

@3
 LDX #$01
 JSR SCROLL_DN_AND_OUT_SCREEN
 JMP EDITOR


;***********************************************************
;  
;
ED_K_DOWN
 copy_ptr ED_P_HI_CUR, MS_PTR_A

 JSR ED_CALC_WIDTH_WIN

;   ,     .
; PTR_A      
;    ,   
; (      ).

ED_K_D_LOOP0
 LDY #$00
 LDA (MS_PTR_A),Y
 CMP #CHAR_CR
 BEQ @0
 JSR INC_MS_PTR_A
 DEC ED_WID_WIN
 BNE ED_K_D_LOOP0
@0

;   PTR_A     

 cmp_ptr_ptr_bne MS_PTR_A, ED_P_HI_BUF, @1
 JSR DOS_BELL
 JMP EDITOR

@1

;           

 JSR ED_CALC_WIDTH_WIN
 LDA ED_PH_COL
 STA ED_VIRT_SPC

ED_K_D_LOOP1
 JSR COPY_CHAR_HI2LO
 CMP #CHAR_CR
 BEQ @2
 LDA ED_PH_COL
 CMP DOS_WIND_X2
 BEQ @3
 INC ED_PH_COL
 BNE ED_K_D_LOOP1		; -JMP.

;   

@2
 LDY #ED_NLINE_DC
 JSR INC_DECIMAL

;     ,    ţ

@3
 LDA DOS_WIND_X1
 STA ED_PH_COL

;  .        ,   

ED_K_D_LOOP2
 LDY #$00
 LDA (ED_P_HI_CUR),Y
 CMP #CHAR_CR
 BEQ ED_K_D_FIN

 LDA ED_PH_COL
 CMP ED_VIRT_SPC		;       
 BEQ ED_K_D_FIN
 JSR COPY_CHAR_HI2LO
 INC ED_PH_COL
 BNE ED_K_D_LOOP2		; -JMP.

;    
;  :
;   VIRT_SPC =   -  
;    = 

ED_K_D_FIN
 LDA ED_VIRT_SPC
 SEC
 SBC ED_PH_COL
 LDX ED_VIRT_SPC
 STX ED_PH_COL
 STA ED_VIRT_SPC

;     

 JMP ED_K_R_NEXT_PH_LINE


;***********************************************************
;  
;
ED_K_UP
 copy_ptr ED_P_LO_CUR, MS_PTR_A

 JSR ED_CALC_WIDTH_WIN

;    ,
;        .
;  У    -  .

ED_K_U_LOOP0
 cmp_ptr_ptr_bne MS_PTR_A, ED_P_LO_BUF, @0
 JSR DOS_BELL
 JMP EDITOR

@0
 JSR DEC_MS_PTR_A
 DEC ED_WID_WIN
 BEQ ED_K_U_LOOP0FIN

 LDY #$00
 LDA (MS_PTR_A),Y
 CMP #CHAR_CR
 BNE ED_K_U_LOOP0

ED_K_U_LOOP0FIN

; : WID_WIN =   - VIRT_SPC
;         -
;   WID_WIN   ,      .
;     ,     VIRT_SPC .

 JSR ED_CALC_WIDTH_WIN
 SEC
 SBC ED_VIRT_SPC
 STA ED_WID_WIN

;     ,       

ED_K_U_LOOP1
 JSR COPY_CHAR_LO2HI
 CMP #CHAR_CR
 BEQ @1
 DEC ED_WID_WIN
 BNE ED_K_U_LOOP1

;   ,       

 LDA #$00
 STA ED_VIRT_SPC
 JMP ED_K_L_PREV_PH_LINE

@1

; WID_WIN = -(        ) + \
;   - 1 +   
; (WID_WIN      +    ,
; ..  ,      )

 copy_ptr ED_P_LO_CUR, MS_PTR_B

 JSR CALC_PHYS_LINE_PTR2	; WID_WIN       
 DEC ED_WID_WIN
 LDA ED_P_LO_CUR+0
 SEC
 SBC MS_PTR_A+0
 CLC
 ADC ED_WID_WIN
 CLC
 ADC DOS_WIND_X1
 STA ED_WID_WIN

;  ,     
; WID_WIN -      
; PH_COL -     
;    :
; WID_WIN = 0 (     )
; 
; WID_WIN <= PH_COL (VIRT_SPC >= 0)

ED_K_U_LOOP2
 LDA ED_PH_COL			;   
 CMP ED_WID_WIN			;   --
 BCS ED_K_U_FIN
 JSR COPY_CHAR_LO2HI
 DEC ED_WID_WIN
; BNE ED_K_U_LOOP2		; -JMP.   PH_COL > 0,    ģ    
 JMP ED_K_U_LOOP2		;    ! ED_WID_WIN   ̣,          

;  VIRT_SPC = PH_COL - WID_WIN

ED_K_U_FIN
 SBC ED_WID_WIN			; C=1
 STA ED_VIRT_SPC
 JMP ED_K_L_PREV_PH_LINE
