;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   
;  ,    16- 
;

;
;  
;
.macro set_ptr ptr, val
 lda #<(val)		;     , ,  val - ,  
 sta ptr+0
 lda #>(val)
 sta ptr+1
.endmacro

.macro set_ptr_AX val
 ldx #<(val)
 lda #>(val)
.endmacro

;
;   src  dst1 ,  , dst2  dst3
;
.macro copy_ptr src, dst1, dst2, dst3
 lda src+0
 sta dst1+0
 .ifnblank dst2
   sta dst2+0
 .endif
 .ifnblank dst3
   sta dst3+0
 .endif

 lda src+1
 sta dst1+1
 .ifnblank dst2
   sta dst2+1
 .endif
 .ifnblank dst3
   sta dst3+1
 .endif
.endmacro

;
;  
;
.macro cmp_ptr_ptr_bne v1, v2, lab
 lda v1+0
 cmp v2+0
 bne lab
 lda v1+1
 cmp v2+1
 bne lab
.endmacro

.macro cmp_ptr_ptr_beq v1, v2, lab
 .local @0
 lda v1+0
 cmp v2+0
 bne @0
 lda v1+1
 cmp v2+1
 beq lab
@0:
.endmacro

.macro cmp_ptr_ptr v1, v2
 lda v1+0
 cmp v2+0
 lda v1+1
 sbc v2+1
.endmacro

.macro cmp_ptr_word v1, val
 lda v1+0
 cmp #<(val)
 lda v1+1
 sbc #>(val)
.endmacro

;
;   
;
.macro inc_ptr ptr
 .local @0
 inc ptr+0
 bne @0
 inc ptr+1
@0:
.endmacro

.macro dec_ptr ptr
 .local @0
 lda ptr+0
 bne @0
 dec ptr+1
@0:
 dec ptr+0
.endmacro

;
;    
;
.macro add2_ptr_byte ptr, val
 .local @0
 clc
 lda ptr+0
 adc #val
 sta ptr+0
 bcc @0
 inc ptr+1
@0:
.endmacro

.macro sub2_ptr_byte ptr, val
 .local @0
 sec
 lda ptr+0
 sbc #val
 sta ptr+0
 bcs @0
 dec ptr+1
@0:
.endmacro

.macro add3_ptr_ptr a1, a2, res
 clc
 lda a1+0
 adc a2+0
 sta res+0
 lda a1+1
 adc a2+1
 sta res+1
.endmacro

.macro sub3_ptr_ptr a1, a2, res
 sec
 lda a1+0
 sbc a2+0
 sta res+0
 lda a1+1
 sbc a2+1
 sta res+1
.endmacro

.macro add3_ptr_word a1, val, res
 clc
 lda a1+0
 adc #<(val)
 sta res+0
 lda a1+1
 adc #>(val)
 sta res+1
.endmacro

.macro sub3_ptr_word a1, val, res
 sec
 lda a1+0
 sbc #<(val)
 sta res+0
 lda a1+1
 sbc #>(val)
 sta res+1
.endmacro

;
;  IOSub
;
.macro print str
 jsr IOS_PRINT
 .byte str
 .byte $8D, $00
.endmacro

.macro print_WO_CR str
 jsr IOS_PRINT
 .asciiz str
.endmacro

;
;     
;   ,          
;
.macro build_data pref
 year = .time / 31556926 + 1970
 year_m = .time .mod 31556926
 month = year_m / 2629743 + 1
 month_m = year_m .mod 2629743
 day = month_m / 86400 + 1
;   ca65: pref     ,     
; .asciiz .sprintf("%s %02d.%02d.%04d", pref, day, month, year)

 .asciiz pref, .sprintf(" %02d.%02d.%04d", day, month, year)

.endmacro

;
;   SP
;
.macro sp_check
 .local @1
.bss
@1: .res 1
.code
 tsx
 stx @1
.endmacro
